<!-- 操作员操作 -->
<template>
  <div id="roles" v-loading="lodingtable" >
    <div class="flex flex-m">

      <el-input class="w200 mr10" clearable v-model="search.search" :placeholder="$txt('操作员')"></el-input>

      <el-button size="small" @click="getList" type="primary">{{$txt('搜索')}}</el-button>
      <el-button size="small" @click="opendetail()" type="primary">{{$txt('新增操作员')}}</el-button>
      <el-button size="small" @click="openeditor(role_id,0)" type="primary">{{$txt('设置PC权限')}}</el-button>

      <el-button size="small" @click="deleterole(deletelist)" type="danger">{{$txt('批量删除')}}</el-button>

    </div>

    <el-table class="mt20 mb20" border size="mini" ref="m_table" :max-height="tableHeight" :data="list" :stripe="true" tooltip-effect="dark" highlight-current-row @current-change="setedit" @selection-change="setdelete">
      <el-table-column type="selection" align="center" width="55">
      </el-table-column>
      <el-table-column prop="name" align="center" :label="$txt('用户名')" show-overflow-tooltip>
      </el-table-column>
      <el-table-column align="center" :label="$txt('姓名')" show-overflow-tooltip>
        <template slot-scope="scope">
          {{scope.row.realname}}
        </template>
      </el-table-column>

      <el-table-column align="center" :label="$txt('状态')" show-overflow-tooltip>
         <template slot-scope="scope"><span :class="scope.row.status | statusClass">{{scope.row.status | getLocBaseData('status')}}</span></template>
      </el-table-column>
      <el-table-column align="center" :label="$txt('操作')">
        <template slot-scope="scope">
          <span class="spanb" @click="opendetail(scope.row)">{{$txt('编辑')}}</span><span class="spanr" @click="deleterole([scope.row.id])">删除</span>
        </template>
      </el-table-column>
    </el-table>

    <!-- 分页 -->
    <Paging :pageIndex="page.index" :pageSize="page.size" :pageTotal="page.total*1" @changeSize="changesize" @changeIndex="changeindex"></Paging>

    <!-- 权限 -->
    <el-dialog :title="$txt('权限设置')" :visible.sync="centerDialogVisible" width="600px" >
      <div >

        <div v-loading="lodingrole" element-loading-text="" class="treeBox">
          <el-tree :data="treedata" default-expand-all show-checkbox check-strictly node-key="id" ref="rolestree" highlight-current :props="{label: 'name'}" :expand-on-click-node="false" @current-change="menuAllCheck" @check-change="checkmenu">
          </el-tree>
        </div>

      </div>
      <span slot="footer" class="dialog-footer">
        
        <el-button size="medium" @click="upeditor" type="primary" :loading="loading">{{$txt('确认')}}</el-button>
        <el-button size="medium" @click="centerDialogVisible = false">{{$txt('取消')}}</el-button>
      </span>
    </el-dialog>

    <el-dialog class="detail" :visible.sync="detailDialogVisible" width="400px" center>
      <div>
        <div v-loading="lodingrole">
          <el-form :model="formdata" label-width="100px" :rules="rules" ref="formdata" label-position="left">

            <el-form-item :label="$txt('用户名')" prop="name" v-if="p_isAdd">
              <el-input v-model="formdata.name" :placeholder="$txt('用户名')"></el-input>
            </el-form-item>

            <el-form-item :label="$txt('密码')" prop="password" v-if="p_isAdd">
              <el-input v-model="formdata.password" :placeholder="$txt('密码')"></el-input>
            </el-form-item>

            <el-form-item :label="$txt('密码')" v-if="!p_isAdd">
              <el-input v-model="formdata.password" :placeholder="$txt('密码')"></el-input>
            </el-form-item>

            <el-form-item :label="$txt('姓名')" prop="realname">
              <el-input v-model="formdata.realname" :placeholder="$txt('姓名')"></el-input>
            </el-form-item>

             <el-form-item label="照片" prop="approval_photo">
             <img :src="this.detailData.approval_photo" style="width:100px;"> 
            </el-form-item>

            <el-form-item label="公司资料" prop="company_info">
              <p> {{this.detailData.company_info}} </p>
            </el-form-item>

            <el-form-item label="公司编号" prop="company_no">
              <p> {{this.detailData.company_no}} </p>
            </el-form-item>

             <el-form-item label="公司照片" prop="company_picture">
             <img :src="this.detailData.company_picture" style="width:100px;"> 
            </el-form-item>



            <el-form-item :label="$txt('状态')" prop="status">
              <el-radio-group v-model="formdata.status">
                <el-radio v-for="item in locBaseData.status" :label="item.id" :key="item.id">{{item.name}}</el-radio>
              </el-radio-group>
            </el-form-item>

          </el-form>
        </div>

      </div>
      <span slot="footer" class="dialog-footer">
          <el-button size="medium" type="danger" v-if="formdata.status == 2" @click="sellerReject = true">拒绝注册</el-button>
        <el-button size="medium" @click="updetail" type="primary" :loading="loading">{{$txt('确认')}}</el-button>
        <el-button size="medium" @click="detailDialogVisible = false">{{$txt('取消')}}</el-button>
      </span>
    </el-dialog>

    <el-dialog class="detail" :visible.sync="sellerReject" width="400px" center>
      <div>
        <div v-loading="lodingrole">
          <el-form label-width="100px" :rules="rules" ref="formdata" label-position="left">

            <div v-for="(reject,counter) in sellerRejectData"  v-bind:key="counter"> 
              <span > {{counter +1}} </span> <span class="spanb" style="margin-left:10%" @click="deleteReject">  X </span>
              <el-form-item label="皮桑">
                <el-input v-model="sellerRejectData[counter].message" placeholder="照片太模糊" ></el-input>
              </el-form-item>
              <el-form-item label="行动">
                <el-select v-model="sellerRejectData[counter].action"> 
                  <el-option label="照片" value=1>  </el-option>
                  <el-option label="公司编号" value=2>  </el-option>
                  <el-option label="公司资料" value=3>  </el-option>
                  <el-option label="公司照片" value=4>  </el-option>
                </el-select>
              </el-form-item>
            </div> 

          </el-form>
        </div>

      </div>
      <span slot="footer" class="dialog-footer">
        <el-button size="medium" @click="sendSellerReject" type="danger" :loading="loading">拒绝注册</el-button>
        <el-button size="medium" @click="addReject">取消</el-button>
        <el-button size="medium" @click="sellerReject = false">取消</el-button>
      </span>
    </el-dialog>

  
    
  </div>
</template>

<script>
import Pagemixin from '@/mixins/index'
import { mapGetters } from 'vuex'
import * as api from '@/api/public'
import * as pub from '@/utils/Lfunc'
export default {
  name: 'peopel',
  mixins: [Pagemixin],
  data() {
    return {
      p_isAdd: true,
      pub,
      name: '',
      lodingtable: false,
      lodingrole: false,
      centerDialogVisible: false,
      detailDialogVisible: false,
      search: {
        search: ''
      },
      formdata: {
        id: '',
        name: '',
        password: '',
        realname: '',
        status: '0'
      },
      detailData : { 
        approval_photo: '', 
        company_picture:'', 
        company_info: '',
        company_no:''
      },
      sellerReject:false, 

      sellerRejectData : [
        {
          seller_id:'',
          action:'',
          message:''
        }
      ],

      rules: {
        name: [{ required: true, message: this.$txt('请输入') }],
        password: [
          { required: true, message: this.$txt('请输入')  },
        ],

      },
      role_id: '',
      client_type: '',
      list: [],
      treedata: [],
      deletelist: [],
      RoleCategory: [],
      rolemenupc_list: [],
      rolemenuapp_list: []
    }
  },
  watch: {

  },
  mounted() {
    this.getList()
    api.getRoleCategory().then(_ => {
      this.RoleCategory = _.data
    }).catch(_ => { })
    api.getAllMenuList(0).then(res => {
      this.rolemenupc_list = res.data
    }).catch(_ => { })
    api.getAllMenuList(1).then(res => {
      this.rolemenuapp_list = res.data
    }).catch(_ => { })
  },
  methods: {
    getList() {
      let data = {
        'search': this.search.search,
        'limit': this.page.size,
        'page': this.page.index
      }
      this.role_id = ''
      this.lodingtable = true
      api.operators(data).then(_ => {
        this.page.total = _.data.total
        this.list = _.data.data
        this.lodingtable = false
        
      }).catch(_ => {
        this.lodingtable = false
      })
    },

    addReject(){
        this.sellerRejectData[0].seller_id = this.formdata.id
        if(this.sellerRejectData.length == 4) { 
          this.m_error('讯息已满')
        }
        else { 
          this.sellerRejectData.push({
            seller_id:this.formdata.id,
            action: '',
            message:''
          })
        }
        

        console.log(this.sellerRejectData)
      },

    deleteReject(counter){
    this.sellerRejectData.splice(counter,1);
    },

    sendSellerReject() { 
      let sendData = {
        seller_reject_reason : this.sellerRejectData
      }
       this.m_api.reject_seller(sendData).then(_ => {
        this.m_success('被拒绝')
        
      }).catch(_ => {
       
      })
    },

    opendetail(row) {                            //编辑_添加 角色详情
      this.detailDialogVisible = true
      this.formdata = {
        // id:'',
        name: '',
        password: '',
        realname: '',
        status: '0'
      }
      this.p_isAdd = true
      console.log(row)
      if (row) {
        this.p_isAdd = false
        this.formdata.id = row.id
        this.formdata.name = row.name
        this.formdata.password = row.password || ''
        this.formdata.realname = row.realname
        this.formdata.status = row.status + ''

        this.detailData.company_picture = row.company_picture
        this.detailData.company_info = row.company_info
        this.detailData.company_no = row.company_no
        this.detailData.approval_photo = row.approval_photo
        
      }
    },
    updetail() {                                 //确认编辑角色详情
      this.$refs['formdata'].validate((valid) => {
        if (valid) {
          if (this.formdata.id) {
            api.edit_operators(this.formdata).then(res => {
              this.detailDialogVisible = false
              this.$message({
                message:  this.$txt('操作成功'),
                type: 'success'
              })
              this.getList()
            }).catch(_ => { })
          } else {
            api.add_operators(this.formdata).then(res => {
              this.detailDialogVisible = false
              this.$message({
                message: this.$txt('操作成功'),
                type: 'success'
              })
              this.getList()
            }).catch(_ => { })
          }
        } else {
          return false
        }
      })
    },
    openeditor(val, isPc) {                       //打开权限详情
      if (!this.role_id) {
        this.$message({
          message: this.$txt('请选择角色'),
          type: 'warning'
        })
        return
      }
      this.centerDialogVisible = true
      this.client_type = isPc
      this.role_id = val
      if (isPc) {
        this.treedata = this.rolemenuapp_list
      } else {
        this.treedata = this.rolemenupc_list
      }
      this.lodingrole = true
      setTimeout(_ => {
        this.$refs.rolestree.setCheckedKeys([])
        api.get_user_permission({ user_id: val, client_type: isPc }).then(_ => {
          this.$refs.rolestree.setCheckedKeys(_.data)
          this.lodingrole = false
        }).catch(_ => {
          this.lodingrole = false
        })
      }, 100)
    },
    upeditor() {                                 //确认权限详情
      api.set_user_permission({ user_id: this.role_id, client_type: this.client_type, permissions: this.$refs.rolestree.getCheckedKeys() }).then(_ => {
        this.$message({
          message: this.$txt('操作成功'),
          type: 'success'
        })
        this.centerDialogVisible = false
        this.getList()
      }).catch(_ => {
        this.centerDialogVisible = false
      })
    },
    menuAllCheck(val, n) {                                   //设置菜单列表全选
      n.checked = !n.checked
      if (n.checked) {
        pub.filterTree(val, this, 'rolestree', 'id')
      }
    },
    checkmenu(val, n, m) {                                    //设置上级被连选
      if (n && val.pid !== 0) {
        this.$refs.rolestree.setChecked(val.pid, true)
      } else if (!n) {
        for (var i in val.children) {
          this.$refs.rolestree.setChecked(val.children[i].id, false, false)
        }
      }
    },
    setedit(val) {
      if (val) {
        this.role_id = val.id
      } else this.role_id = ''
    },
    setdelete(val) {
      this.deletelist =  val.map(i => i.id)
 

      this.$refs.m_table.setCurrentRow(val[val.length - 1])
    },
    deleterole(id) {
      if (!id || id.length === 0) {
        this.$message({
          message: this.$txt('请勾选删除项'),
          type: 'warning'
        })
        return
      }
      this.$confirm(this.$txt('确认删除吗?'), this.$txt('提示'), {
        confirmButtonText: this.$txt('确定'),
        cancelButtonText: this.$txt('取消'),
        type: 'warning'
      }).then(_ => {
        api.del_operators({ id: id }).then(res => {
          this.$message({
            message: this.$txt('操作成功'),
            type: 'success'
          })
          this.getList()
        }).catch(() => {

        })
      }).catch(_ => { })
    },
  },
  computed: {
    ...mapGetters(['loading'])
  },

}

</script>
<style lang='scss' scoped>
.spanb {
  color: #65c7ff;
  margin-right: 5px;
  cursor: pointer;
}
.spanr {
  color: #f56c6c;
  margin-right: 5px;
  cursor: pointer;
}

.treeBox{
  height: 500px;
  overflow: scroll;
}
</style>
<style lang='scss'>
</style>